#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

static void heapsort(uint32_t *arr, uint32_t N)
{
	uint32_t n = N, i = n>>1 , parent, child;
	int t;

	for (;;) 
	{
		if (i > 0) 
		{
			i--;
			t = arr[i];
		} 
		else 
		{
			n--;
			if (n == 0) return;
			t = arr[n];
			arr[n] = arr[0];
		}

		parent = i;
		child = (i<<1) + 1;

		while (child < n) {
			if (child + 1 < n  &&  arr[child + 1] > arr[child]) 
			{
				child++;
			}
			if (arr[child] > t) 
			{
				arr[parent] = arr[child];
				parent = child;
				child = (parent<<1) + 1;
			} 
			else 
			{
				break;
			}
		}
		arr[parent] = t;
	}
}

static uint32_t buffer[256];

int main()
{
	char line[128];
	uint32_t n;
	uint32_t i;
	for(;;)
	{
		if (fgets(line,80,stdin)==NULL)
			break;
		n=0;
		n=strtoul(line,NULL,0);
		if (n==0)
			break;
		for(i=0;i<n;i++)
		{
			fgets(line,80,stdin);
			buffer[i]=strtoul(line,NULL,0);
		}
		printf("------- Sorting %d numbers -------\n",n);
		heapsort(buffer,n);
		for(i=0;i<n;i++)
		{
			printf("%3d : %06x\n",i,buffer[i]);
		}
	}
	return 0;
}
